// Code generated by entc, DO NOT EDIT.

package license

const (
	// Label holds the string label denoting the license type in the database.
	Label = "license"
	// FieldID holds the string denoting the id field in the database.
	FieldID = "id"
	// FieldSpdxID holds the string denoting the spdx_id field in the database.
	FieldSpdxID = "spdx_id"
	// FieldName holds the string denoting the name field in the database.
	FieldName = "name"
	// FieldReference holds the string denoting the reference field in the database.
	FieldReference = "reference"
	// FieldDetailsURL holds the string denoting the details_url field in the database.
	FieldDetailsURL = "details_url"
	// FieldIsOsiApproved holds the string denoting the is_osi_approved field in the database.
	FieldIsOsiApproved = "is_osi_approved"
	// EdgeComponents holds the string denoting the components edge name in mutations.
	EdgeComponents = "components"
	// EdgeUses holds the string denoting the uses edge name in mutations.
	EdgeUses = "uses"
	// Table holds the table name of the license in the database.
	Table = "license"
	// ComponentsTable is the table that holds the components relation/edge. The primary key declared below.
	ComponentsTable = "component_licenses"
	// ComponentsInverseTable is the table name for the Component entity.
	// It exists in this package in order to avoid circular dependency with the "component" package.
	ComponentsInverseTable = "component"
	// UsesTable is the table that holds the uses relation/edge.
	UsesTable = "license_use"
	// UsesInverseTable is the table name for the LicenseUse entity.
	// It exists in this package in order to avoid circular dependency with the "licenseuse" package.
	UsesInverseTable = "license_use"
	// UsesColumn is the table column denoting the uses relation/edge.
	UsesColumn = "license_use_license"
)

// Columns holds all SQL columns for license fields.
var Columns = []string{
	FieldID,
	FieldSpdxID,
	FieldName,
	FieldReference,
	FieldDetailsURL,
	FieldIsOsiApproved,
}

var (
	// ComponentsPrimaryKey and ComponentsColumn2 are the table columns denoting the
	// primary key for the components relation (M2M).
	ComponentsPrimaryKey = []string{"component_id", "license_id"}
)

// ValidColumn reports if the column name is valid (part of the table columns).
func ValidColumn(column string) bool {
	for i := range Columns {
		if column == Columns[i] {
			return true
		}
	}
	return false
}

var (
	// SpdxIDValidator is a validator for the "spdx_id" field. It is called by the builders before save.
	SpdxIDValidator func(string) error
	// NameValidator is a validator for the "name" field. It is called by the builders before save.
	NameValidator func(string) error
	// DefaultIsOsiApproved holds the default value on creation for the "is_osi_approved" field.
	DefaultIsOsiApproved bool
)
