// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/codescan"
	"github.com/valocode/bubbly/ent/license"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/releasecomponent"
	"github.com/valocode/bubbly/ent/releaselicense"
)

// ReleaseLicenseQuery is the builder for querying ReleaseLicense entities.
type ReleaseLicenseQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.ReleaseLicense
	// eager-loading edges.
	withLicense   *LicenseQuery
	withComponent *ReleaseComponentQuery
	withRelease   *ReleaseQuery
	withScans     *CodeScanQuery
	withFKs       bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the ReleaseLicenseQuery builder.
func (rlq *ReleaseLicenseQuery) Where(ps ...predicate.ReleaseLicense) *ReleaseLicenseQuery {
	rlq.predicates = append(rlq.predicates, ps...)
	return rlq
}

// Limit adds a limit step to the query.
func (rlq *ReleaseLicenseQuery) Limit(limit int) *ReleaseLicenseQuery {
	rlq.limit = &limit
	return rlq
}

// Offset adds an offset step to the query.
func (rlq *ReleaseLicenseQuery) Offset(offset int) *ReleaseLicenseQuery {
	rlq.offset = &offset
	return rlq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (rlq *ReleaseLicenseQuery) Unique(unique bool) *ReleaseLicenseQuery {
	rlq.unique = &unique
	return rlq
}

// Order adds an order step to the query.
func (rlq *ReleaseLicenseQuery) Order(o ...OrderFunc) *ReleaseLicenseQuery {
	rlq.order = append(rlq.order, o...)
	return rlq
}

// QueryLicense chains the current query on the "license" edge.
func (rlq *ReleaseLicenseQuery) QueryLicense() *LicenseQuery {
	query := &LicenseQuery{config: rlq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rlq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rlq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(releaselicense.Table, releaselicense.FieldID, selector),
			sqlgraph.To(license.Table, license.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, releaselicense.LicenseTable, releaselicense.LicenseColumn),
		)
		fromU = sqlgraph.SetNeighbors(rlq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryComponent chains the current query on the "component" edge.
func (rlq *ReleaseLicenseQuery) QueryComponent() *ReleaseComponentQuery {
	query := &ReleaseComponentQuery{config: rlq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rlq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rlq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(releaselicense.Table, releaselicense.FieldID, selector),
			sqlgraph.To(releasecomponent.Table, releasecomponent.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, releaselicense.ComponentTable, releaselicense.ComponentColumn),
		)
		fromU = sqlgraph.SetNeighbors(rlq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryRelease chains the current query on the "release" edge.
func (rlq *ReleaseLicenseQuery) QueryRelease() *ReleaseQuery {
	query := &ReleaseQuery{config: rlq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rlq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rlq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(releaselicense.Table, releaselicense.FieldID, selector),
			sqlgraph.To(release.Table, release.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, releaselicense.ReleaseTable, releaselicense.ReleaseColumn),
		)
		fromU = sqlgraph.SetNeighbors(rlq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryScans chains the current query on the "scans" edge.
func (rlq *ReleaseLicenseQuery) QueryScans() *CodeScanQuery {
	query := &CodeScanQuery{config: rlq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := rlq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := rlq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(releaselicense.Table, releaselicense.FieldID, selector),
			sqlgraph.To(codescan.Table, codescan.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, releaselicense.ScansTable, releaselicense.ScansColumn),
		)
		fromU = sqlgraph.SetNeighbors(rlq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first ReleaseLicense entity from the query.
// Returns a *NotFoundError when no ReleaseLicense was found.
func (rlq *ReleaseLicenseQuery) First(ctx context.Context) (*ReleaseLicense, error) {
	nodes, err := rlq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{releaselicense.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) FirstX(ctx context.Context) *ReleaseLicense {
	node, err := rlq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first ReleaseLicense ID from the query.
// Returns a *NotFoundError when no ReleaseLicense ID was found.
func (rlq *ReleaseLicenseQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = rlq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{releaselicense.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) FirstIDX(ctx context.Context) int {
	id, err := rlq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single ReleaseLicense entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one ReleaseLicense entity is not found.
// Returns a *NotFoundError when no ReleaseLicense entities are found.
func (rlq *ReleaseLicenseQuery) Only(ctx context.Context) (*ReleaseLicense, error) {
	nodes, err := rlq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{releaselicense.Label}
	default:
		return nil, &NotSingularError{releaselicense.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) OnlyX(ctx context.Context) *ReleaseLicense {
	node, err := rlq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only ReleaseLicense ID in the query.
// Returns a *NotSingularError when exactly one ReleaseLicense ID is not found.
// Returns a *NotFoundError when no entities are found.
func (rlq *ReleaseLicenseQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = rlq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = &NotSingularError{releaselicense.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) OnlyIDX(ctx context.Context) int {
	id, err := rlq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of ReleaseLicenses.
func (rlq *ReleaseLicenseQuery) All(ctx context.Context) ([]*ReleaseLicense, error) {
	if err := rlq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return rlq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) AllX(ctx context.Context) []*ReleaseLicense {
	nodes, err := rlq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of ReleaseLicense IDs.
func (rlq *ReleaseLicenseQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := rlq.Select(releaselicense.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) IDsX(ctx context.Context) []int {
	ids, err := rlq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (rlq *ReleaseLicenseQuery) Count(ctx context.Context) (int, error) {
	if err := rlq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return rlq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) CountX(ctx context.Context) int {
	count, err := rlq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (rlq *ReleaseLicenseQuery) Exist(ctx context.Context) (bool, error) {
	if err := rlq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return rlq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (rlq *ReleaseLicenseQuery) ExistX(ctx context.Context) bool {
	exist, err := rlq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the ReleaseLicenseQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (rlq *ReleaseLicenseQuery) Clone() *ReleaseLicenseQuery {
	if rlq == nil {
		return nil
	}
	return &ReleaseLicenseQuery{
		config:        rlq.config,
		limit:         rlq.limit,
		offset:        rlq.offset,
		order:         append([]OrderFunc{}, rlq.order...),
		predicates:    append([]predicate.ReleaseLicense{}, rlq.predicates...),
		withLicense:   rlq.withLicense.Clone(),
		withComponent: rlq.withComponent.Clone(),
		withRelease:   rlq.withRelease.Clone(),
		withScans:     rlq.withScans.Clone(),
		// clone intermediate query.
		sql:  rlq.sql.Clone(),
		path: rlq.path,
	}
}

// WithLicense tells the query-builder to eager-load the nodes that are connected to
// the "license" edge. The optional arguments are used to configure the query builder of the edge.
func (rlq *ReleaseLicenseQuery) WithLicense(opts ...func(*LicenseQuery)) *ReleaseLicenseQuery {
	query := &LicenseQuery{config: rlq.config}
	for _, opt := range opts {
		opt(query)
	}
	rlq.withLicense = query
	return rlq
}

// WithComponent tells the query-builder to eager-load the nodes that are connected to
// the "component" edge. The optional arguments are used to configure the query builder of the edge.
func (rlq *ReleaseLicenseQuery) WithComponent(opts ...func(*ReleaseComponentQuery)) *ReleaseLicenseQuery {
	query := &ReleaseComponentQuery{config: rlq.config}
	for _, opt := range opts {
		opt(query)
	}
	rlq.withComponent = query
	return rlq
}

// WithRelease tells the query-builder to eager-load the nodes that are connected to
// the "release" edge. The optional arguments are used to configure the query builder of the edge.
func (rlq *ReleaseLicenseQuery) WithRelease(opts ...func(*ReleaseQuery)) *ReleaseLicenseQuery {
	query := &ReleaseQuery{config: rlq.config}
	for _, opt := range opts {
		opt(query)
	}
	rlq.withRelease = query
	return rlq
}

// WithScans tells the query-builder to eager-load the nodes that are connected to
// the "scans" edge. The optional arguments are used to configure the query builder of the edge.
func (rlq *ReleaseLicenseQuery) WithScans(opts ...func(*CodeScanQuery)) *ReleaseLicenseQuery {
	query := &CodeScanQuery{config: rlq.config}
	for _, opt := range opts {
		opt(query)
	}
	rlq.withScans = query
	return rlq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
func (rlq *ReleaseLicenseQuery) GroupBy(field string, fields ...string) *ReleaseLicenseGroupBy {
	group := &ReleaseLicenseGroupBy{config: rlq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := rlq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return rlq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
func (rlq *ReleaseLicenseQuery) Select(fields ...string) *ReleaseLicenseSelect {
	rlq.fields = append(rlq.fields, fields...)
	return &ReleaseLicenseSelect{ReleaseLicenseQuery: rlq}
}

func (rlq *ReleaseLicenseQuery) prepareQuery(ctx context.Context) error {
	for _, f := range rlq.fields {
		if !releaselicense.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if rlq.path != nil {
		prev, err := rlq.path(ctx)
		if err != nil {
			return err
		}
		rlq.sql = prev
	}
	return nil
}

func (rlq *ReleaseLicenseQuery) sqlAll(ctx context.Context) ([]*ReleaseLicense, error) {
	var (
		nodes       = []*ReleaseLicense{}
		withFKs     = rlq.withFKs
		_spec       = rlq.querySpec()
		loadedTypes = [4]bool{
			rlq.withLicense != nil,
			rlq.withComponent != nil,
			rlq.withRelease != nil,
			rlq.withScans != nil,
		}
	)
	if rlq.withLicense != nil || rlq.withComponent != nil || rlq.withRelease != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, releaselicense.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &ReleaseLicense{config: rlq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, rlq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := rlq.withLicense; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*ReleaseLicense)
		for i := range nodes {
			if nodes[i].release_license_license == nil {
				continue
			}
			fk := *nodes[i].release_license_license
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(license.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_license_license" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.License = n
			}
		}
	}

	if query := rlq.withComponent; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*ReleaseLicense)
		for i := range nodes {
			if nodes[i].release_license_component == nil {
				continue
			}
			fk := *nodes[i].release_license_component
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(releasecomponent.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_license_component" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Component = n
			}
		}
	}

	if query := rlq.withRelease; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*ReleaseLicense)
		for i := range nodes {
			if nodes[i].release_license_release == nil {
				continue
			}
			fk := *nodes[i].release_license_release
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(release.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_license_release" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Release = n
			}
		}
	}

	if query := rlq.withScans; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[int]*ReleaseLicense)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
			nodes[i].Edges.Scans = []*CodeScan{}
		}
		query.withFKs = true
		query.Where(predicate.CodeScan(func(s *sql.Selector) {
			s.Where(sql.InValues(releaselicense.ScansColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.release_license_scans
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "release_license_scans" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "release_license_scans" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Scans = append(node.Edges.Scans, n)
		}
	}

	return nodes, nil
}

func (rlq *ReleaseLicenseQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := rlq.querySpec()
	return sqlgraph.CountNodes(ctx, rlq.driver, _spec)
}

func (rlq *ReleaseLicenseQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := rlq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (rlq *ReleaseLicenseQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   releaselicense.Table,
			Columns: releaselicense.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releaselicense.FieldID,
			},
		},
		From:   rlq.sql,
		Unique: true,
	}
	if unique := rlq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := rlq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, releaselicense.FieldID)
		for i := range fields {
			if fields[i] != releaselicense.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := rlq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := rlq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := rlq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := rlq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (rlq *ReleaseLicenseQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(rlq.driver.Dialect())
	t1 := builder.Table(releaselicense.Table)
	columns := rlq.fields
	if len(columns) == 0 {
		columns = releaselicense.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if rlq.sql != nil {
		selector = rlq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range rlq.predicates {
		p(selector)
	}
	for _, p := range rlq.order {
		p(selector)
	}
	if offset := rlq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := rlq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// ReleaseLicenseGroupBy is the group-by builder for ReleaseLicense entities.
type ReleaseLicenseGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (rlgb *ReleaseLicenseGroupBy) Aggregate(fns ...AggregateFunc) *ReleaseLicenseGroupBy {
	rlgb.fns = append(rlgb.fns, fns...)
	return rlgb
}

// Scan applies the group-by query and scans the result into the given value.
func (rlgb *ReleaseLicenseGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := rlgb.path(ctx)
	if err != nil {
		return err
	}
	rlgb.sql = query
	return rlgb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := rlgb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(rlgb.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := rlgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) StringsX(ctx context.Context) []string {
	v, err := rlgb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = rlgb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) StringX(ctx context.Context) string {
	v, err := rlgb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(rlgb.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := rlgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) IntsX(ctx context.Context) []int {
	v, err := rlgb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = rlgb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) IntX(ctx context.Context) int {
	v, err := rlgb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(rlgb.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := rlgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := rlgb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = rlgb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) Float64X(ctx context.Context) float64 {
	v, err := rlgb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(rlgb.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := rlgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := rlgb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (rlgb *ReleaseLicenseGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = rlgb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (rlgb *ReleaseLicenseGroupBy) BoolX(ctx context.Context) bool {
	v, err := rlgb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (rlgb *ReleaseLicenseGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range rlgb.fields {
		if !releaselicense.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := rlgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := rlgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (rlgb *ReleaseLicenseGroupBy) sqlQuery() *sql.Selector {
	selector := rlgb.sql.Select()
	aggregation := make([]string, 0, len(rlgb.fns))
	for _, fn := range rlgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(rlgb.fields)+len(rlgb.fns))
		for _, f := range rlgb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(rlgb.fields...)...)
}

// ReleaseLicenseSelect is the builder for selecting fields of ReleaseLicense entities.
type ReleaseLicenseSelect struct {
	*ReleaseLicenseQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (rls *ReleaseLicenseSelect) Scan(ctx context.Context, v interface{}) error {
	if err := rls.prepareQuery(ctx); err != nil {
		return err
	}
	rls.sql = rls.ReleaseLicenseQuery.sqlQuery(ctx)
	return rls.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) ScanX(ctx context.Context, v interface{}) {
	if err := rls.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Strings(ctx context.Context) ([]string, error) {
	if len(rls.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := rls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) StringsX(ctx context.Context) []string {
	v, err := rls.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = rls.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) StringX(ctx context.Context) string {
	v, err := rls.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Ints(ctx context.Context) ([]int, error) {
	if len(rls.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := rls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) IntsX(ctx context.Context) []int {
	v, err := rls.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = rls.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) IntX(ctx context.Context) int {
	v, err := rls.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(rls.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := rls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) Float64sX(ctx context.Context) []float64 {
	v, err := rls.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = rls.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) Float64X(ctx context.Context) float64 {
	v, err := rls.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(rls.fields) > 1 {
		return nil, errors.New("ent: ReleaseLicenseSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := rls.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) BoolsX(ctx context.Context) []bool {
	v, err := rls.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (rls *ReleaseLicenseSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = rls.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{releaselicense.Label}
	default:
		err = fmt.Errorf("ent: ReleaseLicenseSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (rls *ReleaseLicenseSelect) BoolX(ctx context.Context) bool {
	v, err := rls.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (rls *ReleaseLicenseSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := rls.sql.Query()
	if err := rls.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
